// *********************************************
// Modificications pour mise en libre :
// Modif B le 31/01/2000 par Marc Dauplait :
// retrait de l'URL d'accs de l'aide en ligne cod en dur par un accs automatique
// au sous-rpertoire /aide sur le serveur
// *********************************************

   package carto.applet;

   import carto.graphe.*;
   import java.awt.*;
   import java.util.Vector;
   import java.applet.AppletContext;
   import java.net.*;
   import java.awt.event.MouseEvent;
   import javax.swing.SwingUtilities.*;
   import MonApplet; /* modif B*/

/** 
 *  Classe qui comme son nom l'indique centralise la gestion des diffrentes fentres. 
 *  Toutes les fentres sont contenues dans un vecteur, qui est un attribut priv. On ajoute ou 
 *  on supprime des lements au vecteur quand on ouvre et ferme des fentres.
 *  @author Fred
 */

   public class Central
   {
      private static Vector vecteurFenetres; 
      private static AppletContext contexte;
   
    /**
     *  Constructeur qui lance en fait l'application quand il est appel.
     *  @param contexte Donne le contexte dans lequel vont tre affichs les documents html
     *  @param fichier Donne le nom du premier fichier xml  afficher
     */
      public Central(AppletContext contexte, String fichier)
      {
         vecteurFenetres=new Vector();
         this.contexte=contexte;
      
         vecteurFenetres.add(new Fenetre(0,3,1));
         ((Fenetre) vecteurFenetres.elementAt(0)).setNomFichierXML(fichier);
         ((Fenetre) vecteurFenetres.elementAt(0)).setVisible(true);
         //((Fenetre) vecteurFenetres.elementAt(0)).repaint();
      }
   
    /**
     *  Methode invoqu quand on veut afficher un graphe d'index
     */
   
      public static void afficheIndex()
      {
         vecteurFenetres.add(new Fenetre(vecteurFenetres.size(),3,2));
         ((Fenetre) vecteurFenetres.elementAt((vecteurFenetres.size()-1))).setNomFichierXML("index.xml");
         ((Fenetre) vecteurFenetres.elementAt((vecteurFenetres.size()-1))).repaint();
      }
   
    /**
     *  Methode invoqu quand on veut afficher un graphe d'aide
     */
   
      public static void afficheAide()
      {
         vecteurFenetres.add(new Fenetre(vecteurFenetres.size(),3,1));
         ((Fenetre) vecteurFenetres.elementAt((vecteurFenetres.size()-1))).setNomFichierXML("aide.xml");
         ((Fenetre) vecteurFenetres.elementAt((vecteurFenetres.size()-1))).repaint();
      }
   
    /**
     *  Mthode invoque si l'utilisateur clique sur un noeud. Elle cre une nouvelle fentre ou 
     *  change le contenu des fentres dj ouvertes en fonction du bouton clique. Il y a en effet 
     *  deux solutions, soit l'utilisateur a cliqu sur le bouton gauche, soit le droit. Dans le premier 
     *  cas, on regarde si la fentre dans laquelle on a cliqu possde une fentre fille, si oui on 
     *  affiche le nouveau graphe dans celle-ci. Sinon, on affiche dans la mme fentre. Dans le deuxime 
     *  cas, quand l'utilisateur appuie sur le bouton gauche, on cre une fentre fille  notre fentre et 
     *  on y affiche notre graphe.
     *  @param index Contient l'index de la fentre dans laquelle l'utilisateur a cliqu
     *  @param lien Contient ventuellement le nom du fichier xml  charger
     *  @param url Contient ventuellement l'url  charger
     *  @param event Contient le MouseEvent qui correspond  l'action de l'utilisateur sur le noeud
     */
   
      public static void actionUtilisateur(int index,String lien,URL url,MouseEvent event)
      {   
         if (javax.swing.SwingUtilities.isLeftMouseButton(event) & !(lien==""))
         {
            if (((Fenetre) vecteurFenetres.elementAt(index)).fenetreFils==null)
            {
               ((Fenetre) vecteurFenetres.elementAt(index)).setNomFichierXML(lien);
               ((Fenetre) vecteurFenetres.elementAt(index)).repaint();
            }
            else
            {
               (((Fenetre) vecteurFenetres.elementAt(index)).fenetreFils).setNomFichierXML(lien);
               (((Fenetre) vecteurFenetres.elementAt(index)).fenetreFils).repaint();
            }
         
         }
         if (javax.swing.SwingUtilities.isRightMouseButton(event) & !(lien==""))
         {
            int style;
         
            if (((Fenetre) vecteurFenetres.elementAt(index)).getStyle()<1)
               style=1;
            else
               style=((Fenetre) vecteurFenetres.elementAt(index)).getStyle();
            vecteurFenetres.add(new Fenetre(vecteurFenetres.size(),((Fenetre) vecteurFenetres.elementAt(index)).getDifficulte(),1));
            ((Fenetre) vecteurFenetres.elementAt(index)).fenetreFils=(Fenetre) vecteurFenetres.elementAt(vecteurFenetres.size()-1);
            ((Fenetre) vecteurFenetres.elementAt(vecteurFenetres.size()-1)).fenetrePere=(Fenetre) vecteurFenetres.elementAt(index);
            ((Fenetre) vecteurFenetres.elementAt(vecteurFenetres.size()-1)).setNomFichierXML(lien);
            ((Fenetre) vecteurFenetres.elementAt(vecteurFenetres.size()-1)).repaint();
         }
         if (lien=="")
            contexte.showDocument(url,"Explications");
      }
   
    /**
     *  Cette mthode fait oublier  l'applet une fentre ferme par l'utilisateur.
     *@param index Contient l'index de la fentre a faire oublier.
     */
   
      public static void fenetreFerme(int index)
      {
         vecteurFenetres.remove(index);
         for (int i=index;i<vecteurFenetres.size();i++)
            ((Fenetre) vecteurFenetres.elementAt(i)).setIndex(((Fenetre) vecteurFenetres.elementAt(i)).getIndex()-1);
      }
   
    /**
     *  Cette mthode affiche la documentation de l'application dans une fentre du browser ou 
     *  autre qui a lanc l'applet.
     */
   
      public static void afficheAideApplet()
      {
         try
         {
            //contexte.showDocument(new URL("http://mengam/~falempin/doc/index.html"),"Aide");
            contexte.showDocument(new URL(MonApplet.urlApplet.toString()+"aide/index.html"),"Aide"); /* Modif B */
         }
            catch (MalformedURLException e)
            {
            }
      }  
   }













