
package carto.applet;

import java.awt.event.*;

/** Cette classe controlle toutes les actions de l'utilisateur
*  sur la fentre, comme l'action sur les boutons de navigation
*  et de fermeture de fentre, ou mme l'action sur les menus.
*  @author Fred
*/

public class Controlleur implements ActionListener,WindowListener
{    
	protected Fenetre fenetre;
	
    /**
	*  Initialise un controlleur d'venements (un Listener) qui est associ avec la fentre 
	*  passe en paramtre.
	*  @param fenetre Fenetre  laquelle on associe le controlleur d'venements.
	*/
	
	public Controlleur(Fenetre fenetre)
	{
		this.fenetre=fenetre;
	}
	public void windowActivated(WindowEvent evt)
	{}
	public void windowClosed(WindowEvent evt)
	{}
	
	public void windowClosing(WindowEvent evt)
	{
		if (fenetre.fenetreFils!=null)
            fenetre.fenetreFils.controlleur.windowClosing(evt);
		if (fenetre.fenetrePere!=null)
            fenetre.fenetrePere.fenetreFils=null;
		Central.fenetreFerme(fenetre.getIndex());
		fenetre.dispose(); 
	}
	
	public void windowDeactivated(WindowEvent evt)
	{}
	
	public void windowDeiconified(WindowEvent evt)
	{}
	
	public void windowIconified(WindowEvent evt)
	{}
	
	public void windowOpened(WindowEvent evt)
	{}
	
	public void  actionPerformed(ActionEvent evt)
	{
		if (evt.getActionCommand().equals("CHAM"))
		{
            fenetre.setNomFichierXML(fenetre.champFichierXML.getText());
		}
		if (evt.getActionCommand().equals("AIDE"))
		{
            new Aide(fenetre);
		}
		if (evt.getActionCommand().equals("RETO"))
		{
			// bouton "retour au niveau suprieur" qui faisait planter l'applet
            // quand on tait dans le graphe racine. (5/01/00)
			if (!fenetre.panel.getPere().equals("null"))
				fenetre.setNomFichierXML(fenetre.panel.getPere());
		}
		if (evt.getActionCommand().equals("RECH"))
		{
            fenetre.panel.initGraphe();
		}
		if (evt.getActionCommand().equals("INDE"))
		{
            Central.afficheIndex();
		}
		if (evt.getActionCommand().equals("DIFF=1"))
		{
            fenetre.panel.setDifficulte(1);
            fenetre.menuDifficulte.setLabel("Difficulte 1");
		}
		if (evt.getActionCommand().equals("DIFF=2"))
		{   
            fenetre.panel.setDifficulte(2);
            fenetre.menuDifficulte.setLabel("Difficulte 2");
		}
		if (evt.getActionCommand().equals("DIFF=3"))
		{
            fenetre.panel.setDifficulte(3);
            fenetre.menuDifficulte.setLabel("Difficulte 3");
		}
		if (evt.getActionCommand().startsWith("CHEM="))
		{
            fenetre.panel.setNumChemin((new Integer(evt.getActionCommand().substring(5,6))).intValue());
            fenetre.menuChemin.setLabel("Chemin "+(new Integer(evt.getActionCommand().substring(5,6)).intValue()+1));
		}
		fenetre.repaint();
	}
}


