package carto.applet;

import carto.graphe.Chemin;
import java.awt.*;
import java.awt.event.*;
import java.awt.Component;
import java.awt.Container;
import java.awt.Color;
import java.util.Vector;
import javax.swing.*;
import java.net.*;
import MonApplet;


/**
*  Cette classe correspond  la fentre qui contient le panel affichant le graphe.
*  Elle a comme attributs la fentre  partir de laquelle elle a t cre
*  et celle qui a t cre  partir d'elle.
*  @author Fred
*/
public class Fenetre extends JFrame
{
	protected Controlleur controlleur;
	private BorderLayout baseLayout;
	private JPanel baseContainer;
	private JToolBar barreDOutils;
	private JButton boutonRetour;
	private JButton boutonAide;
	private JButton boutonIndex;
	private JLabel labelChampTexte;
    /**
	*  Element de la barre de menu
	*/
	protected JTextField champFichierXML;
	private JScrollPane scrollPanel;
    /**
	*  Le panel dans lequel s'affiche le graphe, qui est contenu par notre fenetre
	*/
	protected PanelGraphe panel;
	private MenuBar barreMenu;
	private Menu menuCommandes;
	private MenuItem retour;
	private MenuItem recharger;
	private MenuItem sommaire;
	private Menu menuReglages;
    /**
	*  Element du menu
	*/
	protected Menu menuDifficulte;
	private MenuItem difficulte1;
	private MenuItem difficulte2;
	private MenuItem difficulte3;
    /**
	*  Element du menu
	*/
	protected Menu menuChemin;
	private Vector vecteurMenuChemins;
	
    /**
	*  Contient la derniere fenetre qui a ete appelee a partir de la fenetre courante.
	*/
	public Fenetre fenetreFils;
    /** 
	*  Contient la fenetre a partir de laquelle celle-ci a ete appelee.
	*/
	public Fenetre fenetrePere;
	
    /**
	* Le constructeur initialise une fentre, et la rend visible. Aucun graphe n'y est encore associ.
	* @param index Correspond  l'index de la fentre dans le vecteur de fentres qui est contenu dans Central. Utile pour signaler  central qu'une action a t effectue sur la fentre.
	* @param difficult Correspond  la difficult dans laquelle on affiche le graphe contenu dans la fentre
	* @param style Correspond au style dans lequel sont dessin les noeuds. Il y a deux style, le style par defaut (numro 1) et le style qui sert  reprsenter les index. 
	*/
	
	public Fenetre(int index,int difficulte,int style)
	{
		super("Graphe");
		
		// Creation du gestionnaire d'actions de l'utilisateur sur la fenetre
		
		controlleur=new Controlleur(this);
		this.addWindowListener(controlleur);
		
		// Creation du container et de son layout
		
		baseContainer = new JPanel();
		baseLayout = new BorderLayout();
		
		baseContainer.setLayout(baseLayout);
		baseContainer.setBackground(Color.white);
		
		// Creation de la barre d'outils
		
		barreDOutils=new JToolBar();
		//barreDOutils.setFloatable(false);
		barreDOutils.setFloatable(true);
		barreDOutils.setBorderPainted(true);
		//barreDOutils.setPreferredSize(new Dimension(1000,43));
		//barreDOutils.setPreferredSize(new Dimension(300,43));
		
		
		boutonRetour = new JButton(new ImageIcon(MonApplet.iconRetour));
		boutonRetour.setToolTipText("Retour au niveau suprieur");
		boutonRetour.addActionListener(controlleur);
		boutonRetour.setActionCommand("RETO");
		boutonRetour.setBorderPainted(false);
		
		boutonAide = new JButton(new ImageIcon(MonApplet.iconAide));
		boutonAide.setToolTipText("Aide");
		boutonAide.addActionListener(controlleur);
		boutonAide.setActionCommand("AIDE");
		boutonAide.setBorderPainted(false);
		
		boutonIndex = new JButton(new ImageIcon(MonApplet.iconIndex));
		boutonIndex.setToolTipText("Index");
		boutonIndex.addActionListener(controlleur);
		boutonIndex.setActionCommand("INDE");
		boutonIndex.setBorderPainted(false);
		
		// Creation d'un label indiquant le contenu du champ de texte 
		// qui suit
		
		labelChampTexte = new JLabel("Fichier XML :");
		
		//Creation du champ du fichier XML charge ou a charger
		
		champFichierXML=new JTextField();
		champFichierXML.addActionListener(controlleur);
		champFichierXML.setActionCommand("CHAM");
		//(int)(champFichierXML.getPreferredSize()).getWidth(),30));
		
		// Creation du panel
		
		panel=new PanelGraphe(this,3,0);
		panel.setIndex(index);
		panel.setDifficulte(difficulte);
		panel.setStyle(style);
		panel.setPreferredSize(new Dimension(700,700));
		panel.setBackground(Color.white);
		
		// Creation du Scroll panel
		
		scrollPanel=new JScrollPane(panel);
		scrollPanel.setPreferredSize(new Dimension(700,700));
		scrollPanel.setBackground(Color.white);
		
		// Creation du menu de la fenetre qui contient le panel qui affiche le graphe
		
		barreMenu=new MenuBar();
		
		menuCommandes=new Menu("Commandes");
		retour=new MenuItem("Retour");
		retour.addActionListener(controlleur);
		retour.setActionCommand("RETO");
		recharger=new MenuItem("Recharger");
		recharger.addActionListener(controlleur);
		recharger.setActionCommand("RECH");
		sommaire=new MenuItem("Index");
		sommaire.addActionListener(controlleur);
		sommaire.setActionCommand("INDE");
		barreMenu.add(menuCommandes);
		menuCommandes.add(retour);
		menuCommandes.add(recharger);
		menuCommandes.add(sommaire);
		
		menuReglages=new Menu("Rglages");
		barreMenu.add(menuReglages);
		
		menuDifficulte=new Menu("Difficult "+difficulte);
		difficulte1=new MenuItem("1 : Dbutant");
		difficulte1.addActionListener(controlleur);
		difficulte1.setActionCommand("DIFF=1");
		difficulte2=new MenuItem("2 : Avanc");
		difficulte2.addActionListener(controlleur);
		difficulte2.setActionCommand("DIFF=2");
		difficulte3=new MenuItem("3 : Expert");
		difficulte3.addActionListener(controlleur);
		difficulte3.setActionCommand("DIFF=3");
		menuReglages.add(menuDifficulte);
		menuDifficulte.add(difficulte1);
		menuDifficulte.add(difficulte2);
		menuDifficulte.add(difficulte3);
		
		menuChemin=new Menu("Chemin 1");
		vecteurMenuChemins=new Vector();
		menuReglages.add(menuChemin);
		
		barreDOutils.addSeparator();
		barreDOutils.add(boutonRetour,barreDOutils);
		barreDOutils.addSeparator();
		barreDOutils.add(boutonIndex,barreDOutils);
		barreDOutils.addSeparator();
		barreDOutils.add(boutonAide,barreDOutils);
		barreDOutils.addSeparator();
		barreDOutils.addSeparator();
		barreDOutils.add(labelChampTexte);
		barreDOutils.add(champFichierXML);
		baseContainer.add(scrollPanel,BorderLayout.CENTER);
		baseContainer.add(barreDOutils,BorderLayout.NORTH);
		
		getContentPane().add(baseContainer);
		
		setMenuBar(barreMenu);
		
		setSize(700,800);
		setResizable(true);
        int largeur = java.awt.Toolkit.getDefaultToolkit().getScreenSize().width;  // La fentre est centre
		int hauteur = java.awt.Toolkit.getDefaultToolkit().getScreenSize().height; // sur l'cran aprs rcupration
		setLocation((largeur-(getSize().width))/2,(hauteur-(getSize().height))/2); // de la rsolution.
		
		//setVisible(true);
}

// Gestion des variables protegees du panel.
public int getIndex()
{
	return panel.getIndex();
}

public void setIndex(int index)
{
	panel.setIndex(index);
}

public int getDifficulte()
{
	return panel.getDifficulte();
}

public int getStyle()
{
	return panel.getStyle();
}  

// Divers

/**
* Selectionne le nom du fichier XML coresspondant au graphe que la fenetre doit afficher. 
* Une fois que le nom est selectionne, cette methode le charge et l'initialise. 
* Il peut donc s'afficher.
*/

public void setNomFichierXML(String nomFichierXML)
{
	panel.setNomFichierXML(nomFichierXML);
	champFichierXML.setText(nomFichierXML);
	panel.initGraphe();
	construitMenu();
}

/**
* Cette mthode initialise le menu contenant les noms des chemins du graphe, 
* car il faut pour cela que le graphe soit construit. La fentre apparait avant 
* la construction du graphe, et seul le menu des chemins est initialis aprs le graphe.
*/

public void construitMenu()
{
	vecteurMenuChemins.removeAllElements();
	menuChemin.removeAll();
	System.out.println(panel.graphe.getVecteurChemin().size());
	for (int i=0;i<(panel.graphe.getVecteurChemin().size());i++)
	{                  
		vecteurMenuChemins.add(new MenuItem((i+1)+" : "+((Chemin) panel.graphe.getVecteurChemin().elementAt(i)).getNomChemin()));
		((MenuItem) vecteurMenuChemins.elementAt(i)).addActionListener(controlleur);
		((MenuItem) vecteurMenuChemins.elementAt(i)).setActionCommand("CHEM="+i);
		menuChemin.add((MenuItem) vecteurMenuChemins.elementAt(i));
	}
} 

public void repaint()
{
	panel.repaint();
	barreDOutils.repaint();
	scrollPanel.repaint();
	scrollPanel.revalidate();
}

public void repaint(int x,int y,int xx, int yy)
{
	panel.repaint(x,y,xx,yy);
	scrollPanel.repaint();
}
}


