package carto.dessin;

import carto.graphe.*;
import java.awt.*;

/**
 * La reprsentation des noeuds. 
 */
public abstract class Circle extends Dessin
{
    protected Noeud noeud;
    //les valeurs calculees avec les attributs de la classe Noeud
    protected int rayon;
    protected int epaisseur;
    
    protected FontMetrics fm;
    
    public Circle(Noeud noeud)
    {
	this.noeud = noeud;
    }
    
    public int getRayon()
    {
	return rayon;
    }
    
    public String toString()
    {
	return ("Couleur: "+couleur.toString()+" X: "+noeud.getCoordX()+" Y: "
		+noeud.getCoordY()+ "\nNom: "+noeud.getNom()+" Symbole: "
		+noeud.getSymbole());
    }
    
    public abstract void etablirDessin();
    
    /**
     * Dessine un Circle.
     * @param g l'objet de l'environement graphique
     */
    public abstract void paint(Graphics g);
    
    protected FontMetrics etablirFont(Graphics g)
    {
	return g.getFontMetrics();
    }
    
    protected int largeur(String mot, FontMetrics font)
    {
	return font.stringWidth(mot);
    }
}
