package carto.dessin;

import carto.graphe.*;
import java.awt.*;

/**
 * Le cercle standard des applets. 
 */
public class CircleClassic extends Circle
{
    public CircleClassic(Noeud noeud)
    {
		super(noeud);
    }
    
    public void etablirDessin()
    { 
		rayon = ((noeud.getVolumeHoraire() + 1) * 10);
		epaisseur = (noeud.getDifficulte() *2);
    }
   
   
    /**
     * Dessine le Cercle.
     * @param g l'objet de l'environement graphique
     */    
    public void paint(Graphics g)
    {
		g.setColor(couleur);
		paintCircleClassic(g);
		//pour le nom et le symbole, on a besoin d'etablir certaines valeurs
		fm = etablirFont(g);
		g.setColor(Color.black);
		paintNom(g);
		paintSymbole(g);
    }
    
   /**
    * Dessine le cercle.
    * @param g environement graphique utilis
    */
    protected void paintCircleClassic(Graphics g) 
    {
		int vrairayon = rayon - epaisseur;
		//g.setXORMode(Color.white);
		g.fillOval(noeud.getCoordX() - rayon, noeud.getCoordY() 
			   - rayon, 2 * rayon, 2 * rayon);
		g.setColor(Color.white);
		g.fillOval(noeud.getCoordX() - vrairayon, noeud.getCoordY() 
			   - vrairayon, 2*vrairayon, 2*vrairayon);
    }
    
   /**
    * Dessine un nom dans un cercle.
    * @param g environement graphique utilis
    */
    protected void paintNom(Graphics g)
    {
		int longnom = largeur(noeud.getNom(),fm);
		g.drawString(noeud.getNom(), noeud.getCoordX() - longnom / 2, 
			noeud.getCoordY() + rayon + 15);
    }
    
    /**
     * Dessine un symbole en bas d'un cercle.
     * @param g environement graphique utilis
     */
    protected void paintSymbole(Graphics g) 
    {
		int longsym = largeur(noeud.getSymbole(),fm);
		g.drawString(noeud.getSymbole(), noeud.getCoordX() - longsym / 2, 
			noeud.getCoordY());
    }
}
