package carto.dessin;

import carto.graphe.*;
import java.awt.*;

/**
 * Le cercle utilis dans l'index du cours. 
 */
public class CircleSommaire extends Circle
{
    
    public CircleSommaire(Noeud noeud)
    {
		super(noeud);
    }
    
    /**
     * Calcule ou tablit tous les attributs ncessaire  l'affichage du cercle.
     */
    public void etablirDessin()
    { 
		rayon = ((noeud.getVolumeHoraire() + 1));
		epaisseur = (noeud.getDifficulte());
    }
    
    
    /**
     * Dessine un NoeudSommaire.
     * @param g l'objet de l'environement graphique
     */	    
    public void paint(Graphics g)
    {
		g.setColor(couleur);
		paintCircleSommaire(g);
      	//pour le nom et le symbole, on a besoin d'etablir certaines valeurs
		fm = etablirFont(g);
		g.setColor(Color.black);
		paintNom(g);
    }
    
    protected void paintCircleSommaire(Graphics g) 
    {
			int vrairayon = rayon - epaisseur;
			//g.setXORMode(Color.white);
			g.fillOval(noeud.getCoordX() - rayon, noeud.getCoordY() 
			   - rayon, 2 * rayon, 2 * rayon);
         g.setColor(Color.white);
         g.fillOval(noeud.getCoordX() - vrairayon, noeud.getCoordY() 
                    - vrairayon, 2*vrairayon, 2*vrairayon);
    }
    
    /**
     * Dessine un nom et un symbole a cote d'un cercle.
     * @param g environement graphique utilis
     */
    protected void paintNom(Graphics g)
    {
		g.drawString(noeud.getSymbole()+" : "+noeud.getNom(), 
		noeud.getCoordX() +10, noeud.getCoordY() + rayon);
    }
}




