   package carto.dessin;

   import carto.graphe.LienChemin;
   import java.awt.*;
   import java.awt.geom.*;

/**
 * La ligne des chemins.
 */
   public class LigneChemin extends Ligne
   {
      private LienChemin lienChemin;
      protected float[] intervalle;
      protected FlecheChemin fleche;
   
   /**
   *Cre un objet ligne avec une trace, une paisseur et une couleur precise.
   *@param inter l'intervalle entre  traces de la ligne
   *@param newep l'paisseur de la ligne
   *@param newcouleur la couleur de la ligne
   *@param x1,y1 les coordonnes du point initial de la ligne
   *@param x2,y2 les coordonnes du point final de la ligne
   */
      public LigneChemin(LienChemin lienCh, float[] inter)
      {
         lienChemin=lienCh;
         intervalle = inter;
         trait = new BasicStroke(epaisseur,BasicStroke.CAP_ROUND,
                                 BasicStroke.JOIN_ROUND,10.0f,intervalle,0.0f); 
      // getDefautWerte aus LienChemin verwenden !!??									
      }
   
   
      public void etablirDessin()
      {
         epaisseur = lienChemin.getDefautEpaisseur();
         xD=lienChemin.getNoeudD().getCoordX();
         yD=lienChemin.getNoeudD().getCoordY();
         xA=lienChemin.getNoeudA().getCoordX();
         yA=lienChemin.getNoeudA().getCoordY();
         angle = setAngle();
         setPoints(); // unterschiedlich fuer Ligne und LigneChemin
         trait = new BasicStroke(epaisseur,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND,10.0f,intervalle,0.0f); 
         fleche=setFlecheChemin();
      }
   
      protected void setPoints()
      {
         int rayonD = lienChemin.getNoeudD().dessin.getRayon();
         int rayonA = lienChemin.getNoeudA().dessin.getRayon();
      
         if ((xD != xA)&&(yD != yA))
         {
            yD -= rayonD;
            yA -= rayonA;
         }
         else if (xD != xA)
         {
            yD -= rayonD;
            yA -= rayonA;
         }
         else 
         {
            yD -= rayonD;
            yA -= rayonA;
            xD += 8;
            xA += 8;
         }
      } 
   
      protected FlecheChemin setFlecheChemin()
      {
         FlecheChemin fleche = new FlecheChemin(lienChemin.getTraceFleche(),
                                             lienChemin.getDefautEpaisseur(), 
                                             xD,yD,xA,yA);
         return fleche;
      }

   /**
    * Dessine une ligne discontinue.
    * @param g l'environement Graphique
    */
      public void paint(Graphics g)
      {
         g2 = (Graphics2D) g;
         g2.setColor(couleur);
         g2.setStroke(trait);
         g2.drawLine(xA,yA,xD,yD);
         fleche.dessinerFleche(g);
      
      }
   }
