// *********************************************
// Modificications pour mise en libre :
// Modif C le 10/02/2000 par Marc Dauplait :
// Test supplmentaire sur action bouton OK (remplacement LienBiDir par un autre)
// *********************************************

   package carto.editor;

   import java.awt.*;
   import java.awt.event.*;
   import javax.swing.*;
   import carto.graphe.*;
   import diva.graph.model.*;

/**
 * La classe pour diter les valeurs d'un lien.
 * @author Claudia
 */
   public class FenetreLien extends JDialog implements ActionListener {		
   
      private JLabel helloLabel, noeudDLabel,typeDLabel, diffDLabel, 
      noeudALabel,typeALabel, diffALabel;
      private JComboBox noeudDMenu, typeDMenu, diffDMenu, 
      noeudAMenu, typeAMenu, diffAMenu;
      private JButton okButton, annulerButton;
      private JRadioButton lienBiDirButton;
      private RadioListener myRadioListener;
      private String choixNoeudD, choixTypeD, choixNoeudA, choixTypeA;
      private int choixDiffD, choixDiffA;
      private boolean choixLienBiDir;
   
      protected EditeurFrame frame;
      protected Edge edge;
   
      public FenetreLien (EditeurFrame aFrame)
      {  
         //creates a modal Dialog with titel "FenetreLien"
         super(aFrame,"FenetreLien",true);
         frame = aFrame;
         init();
         pack();
         setVisible(true);
      }
      
   /**
    * Donne tous les choix de la bote de dialogue.
    */     
      public String toString(){
         return "NoeudD: "+choixNoeudD+" TypeD: "+choixTypeD+" DiffD: "
            +choixDiffD+"\nNoeudA: "+choixNoeudA+" TypeA: "+choixTypeA+
            " DiffA: "+choixDiffA+"\nBiDir: "+choixLienBiDir;
      }
   
      /**
       * Dessine la fentre avec tous les labels et boutons.
       */
      public void init() {
      // main panel
         Container contentPane = getContentPane();
         GridBagLayout grid = new GridBagLayout();
         getContentPane().setLayout(grid);
         int rowHeights[] = {0,30,30,23,30,30,30,30,30,30};
         int columnWidths[] = {0,30,14,1,30};
         double rowWeights[] = {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
         double columnWeights[] = {0.0,0.0,0.0,0.0,0.0};
         grid.rowHeights = rowHeights;
         grid.columnWidths = columnWidths;
         grid.rowWeights = rowWeights;
         grid.columnWeights = columnWeights;
      
         helloLabel = new JLabel();
         helloLabel.setText("Entrez les valeurs pour le lien :");
         contentPane.add(helloLabel);
      
         noeudDLabel = new JLabel();
         noeudDLabel.setForeground(new Color(64000/256,4864/256,16384/256));
         noeudDLabel.setText("Noeud de Dpart");
         contentPane.add(noeudDLabel);
      
         String[] noeuds = getNoeuds();
         noeudDMenu = new JComboBox(noeuds);
         noeudDMenu.setSelectedIndex(0);
         contentPane.add(noeudDMenu);
      
         typeDLabel = new JLabel();
         typeDLabel.setText("Type");
         contentPane.add(typeDLabel);
      
         String[] types = {"Sans", "Conditionnel", "Temporel", "Causalit", 
            "Dveloppement", "Position"};
         typeDMenu = new JComboBox(types);
         typeDMenu.setSelectedIndex(4);
         contentPane.add(typeDMenu);
      
         diffDLabel = new JLabel();
         diffDLabel.setText("Difficult");
         contentPane.add(diffDLabel);
      
         String[] diffs = {"Dbutant", "Avanc", "Expert"};
         diffDMenu = new JComboBox(diffs);
         diffDMenu.setSelectedIndex(1);
         contentPane.add(diffDMenu);
      
         noeudALabel = new JLabel();
         noeudALabel.setForeground(new Color(64000/256,4864/256,16384/256));
         noeudALabel.setText("Noeud d'Arrive");
         contentPane.add(noeudALabel);
      
         noeudAMenu = new JComboBox(noeuds);
         noeudAMenu.setSelectedIndex(1);
         contentPane.add(noeudAMenu);
      
         typeALabel = new JLabel();
         typeALabel.setText("Type");
         contentPane.add(typeALabel);
      
         typeAMenu = new JComboBox(types);
         typeAMenu.setSelectedIndex(4);
         typeAMenu.setEnabled(false);
         contentPane.add(typeAMenu);
      
         diffALabel = new JLabel();
         diffALabel.setText("Difficult");
         contentPane.add(diffALabel);
      
         diffAMenu = new JComboBox(diffs);
         diffAMenu.setSelectedIndex(1);
         diffAMenu.setEnabled(false);
         contentPane.add(diffAMenu);
      
         myRadioListener = new RadioListener();
         lienBiDirButton = new JRadioButton("   Lien bidirectionnel ?");
         lienBiDirButton.setSelected(false);
         lienBiDirButton.addActionListener(myRadioListener);
         contentPane.add(lienBiDirButton);
      
         okButton = new JButton();
         okButton.setText("Ok");
         okButton.setActionCommand( "ok"); 
         okButton.addActionListener(this);
         contentPane.add(okButton);
      
         annulerButton = new JButton();
         annulerButton.setText("Annuler");
         annulerButton.setActionCommand( "annuler"); 
         annulerButton.addActionListener(this);
         contentPane.add(annulerButton);
      
      // Geometry management
         GridBagConstraints con = new GridBagConstraints();
         reset(con);
         con.gridx = 2;
         con.gridy = 1;
         con.gridwidth = 2;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(helloLabel, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 2;
         con.ipadx = 50;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(noeudDLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 2;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(noeudDMenu, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 3;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(noeudALabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 3;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(noeudAMenu, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 4;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(typeDLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 4;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(typeDMenu, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 5;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(diffDLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 5;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(diffDMenu, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 6;
         con.gridwidth = 2;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(lienBiDirButton, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 7;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(typeALabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 7;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(typeAMenu, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 8;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(diffALabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 8;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(diffAMenu, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 9;
         con.ipadx = 40;
         con.insets = new Insets(10, 0, 10, 0);
         con.anchor = GridBagConstraints.WEST;
         con.fill = GridBagConstraints.NONE;
         grid.setConstraints(okButton, con);
      
         /*reset(con);
         con.gridx = 3;
         con.gridy = 9;
         con.insets = new Insets(10, 0, 10, 0);
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.NONE;
         grid.setConstraints(aideButton, con);*/
      
      
         reset(con);
         con.gridx = 3;
         con.gridy = 9;
         con.insets = new Insets(10, 0, 10, 0);
         con.anchor = GridBagConstraints.EAST;
         con.fill = GridBagConstraints.NONE;
         grid.setConstraints(annulerButton, con);
      
      }
   
   /**
    * La mthode demande au graphe tous les indentifieurs des noeuds de ce graphe.
    * @return un tableau des identifieurs des noeuds
    */
      protected String[] getNoeuds(){
         Graphe graphe = (Graphe) frame.getGraphModel().getGraph();
         int size = graphe.getVecteurNoeud().size();
         String[] str = new String[size];
         for (int i=0; i<size; i++)
            str[i] = ((Noeud)graphe.getVecteurNoeud().elementAt(i)).getIdent();
         return str;
      }
   
      public Edge getEdge ()
      { 
         return edge;
      }
   
   
   /**
    * Cherche des valeurs specifies dans la fentre.
    */
      protected void getValeurs(){
         choixNoeudD = (String)noeudDMenu.getSelectedItem();
         choixTypeD = (String)typeDMenu.getSelectedItem();
         String diff = (String)diffDMenu.getSelectedItem();
         if (diff.equals("Dbutant")) choixDiffD=1;
         else if (diff.equals("Avanc")) choixDiffD=2;
         else if (diff.equals("Expert")) choixDiffD=3;
         choixNoeudA = (String)noeudAMenu.getSelectedItem();
         choixTypeA = (String)typeAMenu.getSelectedItem();
         diff = (String)diffAMenu.getSelectedItem();
         if (diff.equals("Dbutant")) choixDiffA=1;
         else if (diff.equals("Avanc")) choixDiffA=2;
         else if (diff.equals("Expert")) choixDiffA=3;
      }
   
   /** 
    * Listens to the radio buttons. 
    * Met le choix pour le deuxime lien visible / non visible.
    */
      class RadioListener implements ActionListener { 
         public void actionPerformed(ActionEvent e) {
            if (choixLienBiDir){
               choixLienBiDir=false;
               typeAMenu.setEnabled(false);
               diffAMenu.setEnabled(false);
            }
            else{
               choixLienBiDir=true;
               typeAMenu.setEnabled(true);
               diffAMenu.setEnabled(true);
            }
         }
      }
      
    /**
     * Les actions pour les deux bouttons "OK" et "Annuler".
     */   
      public void actionPerformed(ActionEvent e) {
      
         if (e.getActionCommand().equals("ok")) {
            getValeurs();
            if ( choixNoeudD.equals(choixNoeudA) ){
               JOptionPane jop = new JOptionPane();
               jop.showMessageDialog(this,"Il faut spcifier deux noeuds diffrents."
                                     ,"Warning",JOptionPane.ERROR_MESSAGE);
            }
            else{
               Noeud noeudD, noeudA;
               Graphe graphe = (Graphe) frame.getGraphModel().getGraph();
               noeudD = graphe.getNoeud(choixNoeudD);
               noeudA = graphe.getNoeud(choixNoeudA);
               if ( (graphe.indexLien(noeudD, noeudA)) != -1) {
                  Edge ed = (Edge) graphe.getVecteurLien().elementAt(graphe.indexLien(noeudD, noeudA));
                  graphe.supprimerLien((Lien) ed);
        // Modif C : test si LienBiDir pour faire 2 removeEdgeMapping
                  if (ed instanceof LienUniDir)										// Modif C
                     frame.getGraphView().removeEdgeMapping(ed, frame.getGraphView().getEdgeFigure(ed));// Modif C
                  else if (ed instanceof LienBiDir) {								// Modif C
                     Edge ed1 = (Edge)( ((LienBiDir)ed).premier() );				// Modif C
                     Edge ed2 = (Edge)( ((LienBiDir)ed).deuxieme() );				// Modif C
                     frame.getGraphView().removeEdgeMapping(ed1, frame.getGraphView().getEdgeFigure(ed1));// Modif C
                     frame.getGraphView().removeEdgeMapping(ed2, frame.getGraphView().getEdgeFigure(ed2));// Modif C
                  }																	// Modif C
               }
               edge=createLien(noeudD, noeudA, choixTypeD, choixDiffD);
               if (choixLienBiDir)  {
                  Lien edgeBiDir;
                  edgeBiDir=createLien(noeudA, noeudD, choixTypeA, choixDiffA);
                  edge = (LienBiDir) ((Graphe)frame.getGraphModel().getGraph()).
                         toLienBi((LienUniDir) edge, (LienUniDir) edgeBiDir);
               }
               dispose();
            }
         }
         else if (e.getActionCommand().equals("annuler")) {
            dispose();
         }
      }
      
    /**
     * Cre un lien unidirectionnel est spcifie le type et la difficult du lien.
     * @return le lien unidirectionnel cr
     */   
      protected LienUniDir createLien(Noeud nD, Noeud nA, String type, int diff)
      {
         LienUniDir edge; 
         if (type.equals("Sans")) edge = new Lien_SANS(nD, nA);
         else if (type.equals("Temporel")) edge = new Lien_T(nD, nA);
         else if (type.equals("Causalit")) edge = new Lien_CA(nD, nA);
         else if (type.equals("Conditionnel")) edge = new Lien_CO(nD, nA);
         else if (type.equals("Position")) edge = new Lien_PO(nD, nA);
         //le type de defaut est "Dveloppement" = la valeur de defaut du ComboBox
         else edge = new Lien_D(nD, nA);
         ((LienUniDir)edge).setDifficulte(diff);
         //"label" sera afficher avec le lien au diteur
         edge.setProperty("label", edge.getType());
         return edge;
      }
   
      private void reset(GridBagConstraints con) {
         con.gridx = GridBagConstraints.RELATIVE;
         con.gridy = GridBagConstraints.RELATIVE;
         con.gridwidth = 1;
         con.gridheight = 1;
      
         con.weightx = 0;
         con.weighty = 0;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.NONE;
      
         con.insets = new Insets(0, 0, 0, 0);
         con.ipadx = 0;
         con.ipady = 0;
      }
   
   }
