   package carto.editor;

   import java.awt.*;
   import java.awt.event.*;
   import javax.swing.*;
   import carto.graphe.*;
   import java.util.Date;

/**
 * Cette classe dessine une fentre pour voir et changer les mta-donnes 
 * du graphe.
 * @author Claudia
 */
   public class FenetreMeta extends JDialog implements ActionListener {		
   
      private JLabel helloLabel, titreLabel, createurLabel, motsClesLabel, 
      versionLabel, niveauLabel, pereLabel, dateLabel;
      private JTextField titreText, createurText, motsClesText, versionText, 
      pereText;
      private JComboBox niveauMenu;
      private String choixTitre, choixCreateur, choixMotsCles, choixPere, 
      choixVersion;
      private int choixNiveau;
      private JButton okButton, annulerButton;
   
      protected EditeurFrame frame;
      protected Graphe graphe;
      //protected Date date;
   
   
      public FenetreMeta (EditeurFrame aFrame)
      {
         //creates a modal Dialog with titel "FenetreMetaGraphe"
         super(aFrame,"FenetreMetaGraphe",true);
         frame = aFrame;
         graphe = (Graphe)frame.getGraphModel().getGraph();
         init();
         pack();
         setVisible(true);
      }

   /**
    * Dessine la fentre avec tous les labels et boutons.
    */   
      public void init() {
      
      // main panel
         Container contentPane = getContentPane();
         GridBagLayout grid = new GridBagLayout();
         getContentPane().setLayout(grid);
         int rowHeights[] = {0,30,30,30,30,30,30,30,30,21};
         int columnWidths[] = {0,30,30,30,30};
         double rowWeights[] = {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
         double columnWeights[] = {0.0,0.0,0.0,0.0,0.0};
         grid.rowHeights = rowHeights;
         grid.columnWidths = columnWidths;
         grid.rowWeights = rowWeights;
         grid.columnWeights = columnWeights;
      
         helloLabel = new JLabel();
         helloLabel.setText("Entrez les valeurs pour le graphe :");
         contentPane.add(helloLabel);
      
         titreLabel = new JLabel();
         titreLabel.setText("Titre");
         contentPane.add(titreLabel);
      
         titreText = new JTextField(graphe.meta.getTitre(), 20);
         contentPane.add(titreText);
      
         createurLabel = new JLabel();
         createurLabel.setText("Crateur");
         contentPane.add(createurLabel);
      
         createurText = new JTextField(graphe.meta.getCreateur(), 20);
         contentPane.add(createurText);
      
         motsClesLabel = new JLabel();
         motsClesLabel.setText("Mots cls");
         contentPane.add(motsClesLabel);
      
         motsClesText = new JTextField(graphe.meta.getMotsCles(), 20);
         contentPane.add(motsClesText);
      
         versionLabel = new JLabel();
         versionLabel.setText("Version");
         contentPane.add(versionLabel);
      
         versionText = new JTextField(graphe.meta.getVersion(), 20);
         contentPane.add(versionText);
      
         niveauLabel = new JLabel();
         niveauLabel.setText("Niveau");
         contentPane.add(niveauLabel);
      
         String[] nivs = {"1", "2", "3", "4", "5"};
         niveauMenu = new JComboBox(nivs);
         niveauMenu.setSelectedIndex(graphe.meta.getNiveau()-1);
         contentPane.add(niveauMenu);
      
         pereLabel = new JLabel();
         pereLabel.setText("Pre");
         contentPane.add(pereLabel);
      
         pereText = new JTextField(graphe.meta.getPere(), 20);
         contentPane.add(pereText);
      
         okButton = new JButton();
         okButton.setText("OK");
         okButton.setActionCommand( "ok"); 
         okButton.addActionListener(this);
         contentPane.add(okButton);
      
         annulerButton = new JButton();
         annulerButton.setText("Annuler");
         annulerButton.setActionCommand( "annuler");
         annulerButton.addActionListener(this);
         contentPane.add(annulerButton);
      
      // Geometry management
         GridBagConstraints con = new GridBagConstraints();
         reset(con);
         con.gridx = 2;
         con.gridy = 1;
         con.gridwidth = 2;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(helloLabel, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 2;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(titreLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 2;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(titreText, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 3;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(createurLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 3;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(createurText, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 4;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(motsClesLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 4;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(motsClesText, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 5;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(versionLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 5;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(versionText, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 6;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(niveauLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 6;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(niveauMenu, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 7;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(pereLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 7;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(pereText, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 8;
         con.ipadx = 40;
         con.insets = new Insets(10, 0, 10, 0);
         con.anchor = GridBagConstraints.WEST;
         con.fill = GridBagConstraints.NONE;
         grid.setConstraints(okButton, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 8;
         con.insets = new Insets(10, 0, 10, 0);
         con.anchor = GridBagConstraints.EAST;
         con.fill = GridBagConstraints.NONE;
         grid.setConstraints(annulerButton, con);
      }
   
      
   /**
    * Donne tous les choix de la bote de dialogue.
    */   
      public String toString(){
         return ("Titre: "+choixTitre+" Craeteur: "+choixCreateur+ "MotsCles: "
                 +choixMotsCles+"\nPere: "+choixPere                 
                 +" Version: "+choixVersion+" Niveau: "+choixNiveau);
      }
      
    /**
     * Prend les valeurs tapes dans la bote de dialogue.
     */    
      public void getValeurs(){
         String niv = "1";
         choixTitre = titreText.getText();
         choixCreateur = createurText.getText();               
         choixMotsCles = motsClesText.getText();         
         choixPere = pereText.getText();
      	 if ( ((String)niveauMenu.getSelectedItem()) != null) 
      		niv = (String)niveauMenu.getSelectedItem();
         choixNiveau = (new Integer(niv)).intValue();
         choixVersion =versionText.getText();
      }
   
      
    /**
     * Les actions pour les deux bouttons "OK" et "Annuler".
     */     
      public void actionPerformed(ActionEvent e) {
      
         if (e.getActionCommand().equals("ok")) {
            getValeurs();
            graphe.meta.setMetaGraphe(choixTitre, choixCreateur, 
                                      choixMotsCles, choixVersion, 
                                      choixPere, choixNiveau);
            frame.setTitle("Editeur de Graphe - " + choixTitre);
            dispose();
         }
         else if (e.getActionCommand().equals("annuler")) {
            dispose();
         }
      }
   
      private void reset(GridBagConstraints con) {
         con.gridx = GridBagConstraints.RELATIVE;
         con.gridy = GridBagConstraints.RELATIVE;
         con.gridwidth = 1;
         con.gridheight = 1;
      
         con.weightx = 0;
         con.weighty = 0;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.NONE;
      
         con.insets = new Insets(0, 0, 0, 0);
         con.ipadx = 0;
         con.ipady = 0;
      }
   
   }
