// *********************************************
// Modificications pour mise en libre :
// Modif D le 10/02/2000 par Marc Dauplait :
// Correction 2 bugs :
//   - Validation d'un noeud sans identificateur tait signal mais pas interdit
//   - Modification d'un noeud impossible car le logiciel signalait que le noeud existait dj
// *********************************************

   package carto.editor;

   import java.awt.*;
   import java.awt.event.*;
   import javax.swing.*;
   import java.util.Vector;

   import diva.graph.model.Node;
   import diva.canvas.*;

   import carto.graphe.*;

/**
 * La classe pour diter les valeurs d'un noeud.
 * @author Claudia
 */
   public class FenetreNoeud extends JDialog implements ActionListener{		
   
      private JLabel helloLabel, identLabel, typeLabel, nomLabel, symboleLabel, 
      	diffLabel, volumeLabel, zoomLabel, supportLabel, urlLabel;
      private JTextField identText, nomText, symText, zoomText, urlText;
      private JComboBox typeMenu, diffMenu, volumeMenu, supportMenu;
      private JButton okButton, annulerButton;
      private String choixIdent, choixType, choixNom, choixSymbole, choixZoom, 
      	choixURL, choixSupport;
      private int choixDiff, choixVolume;
      private boolean modifier;
      private Noeud noeudAModifier;
   
      protected EditeurFrame frame;
      protected Graphe graphe;
      protected Noeud noeud;
      protected double nodeX=40, nodeY=40;
   
    /** Constructeur qui ouvre un dialogue pour crer un nouveau noued.*/
      public FenetreNoeud (EditeurFrame aFrame)
      {
         //creates a modal Dialog with titel "FenetreNoeud"
         super(aFrame,"FenetreNoeud",true);
         frame = aFrame; 
         noeud = new Noeud_M();
         modifier = false;
         init();
         pack();
         setVisible(true);
      }
   
    /** Constructeur qui place le dialogue et le noued o la souris tait clique.*/
      public FenetreNoeud (EditeurFrame aFrame, double nodeX, double nodeY)
      {
         super(aFrame,"FenetreNoeud",true);
         frame = aFrame; 
         noeud = new Noeud_M();
         modifier = false;
         this.nodeX = nodeX;
         this.nodeY = nodeY;
         init();
         pack();
         setLocation((int)nodeX,(int)nodeY);
         setVisible(true);
      }
   
      /** Constructeur qui ouvre le dialogue avec les valeurs du noued cliqu.*/
      public FenetreNoeud (EditeurFrame aFrame, Noeud noeud)
      {
         //creates a modal Dialog with titel "FenetreNoeud"
         super(aFrame,"FenetreNoeud",true);
         frame = aFrame;
         this.noeud = noeud;
         this.noeudAModifier = noeud;
         this.nodeX = noeud.getCoordX();
         this.nodeY = noeud.getCoordY();
         modifier = true;
         init();
         pack();
         setVisible(true);
      }

   /**
    * Dessine la fentre avec tous les labels et boutons.
    */   
      public void init() {
      
      // main panel
         Container contentPane = getContentPane();
         GridBagLayout grid = new GridBagLayout();
         getContentPane().setLayout(grid);
         int rowHeights[] = {0,30,30,30,30,30,30,30,30,30,30};
         int columnWidths[] = {0,30,30,30,30};
         double rowWeights[] = {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
         double columnWeights[] = {0.0,0.0,0.0,0.0,0.0};
         grid.rowHeights = rowHeights;
         grid.columnWidths = columnWidths;
         grid.rowWeights = rowWeights;
         grid.columnWeights = columnWeights;
      
         helloLabel = new JLabel();
         helloLabel.setText("Entrez les valeurs pour le noeud :");
         contentPane.add(helloLabel);
      
         identLabel = new JLabel();
         identLabel.setForeground(new Color(64000/256,4864/256,16384/256));
         identLabel.setText("Identifieur");
         contentPane.add(identLabel);
      
         identText = new JTextField(noeud.getIdent(), 20); 
         contentPane.add(identText);
      
         typeLabel = new JLabel();
         typeLabel.setText("Type");
         contentPane.add(typeLabel);
      
         String[] types = {"Magistral", "Travail pratique", "Travail dirig"};
         int sel = 0;
         if ( noeud.getType().equals("magistral") ) sel = 0; 
         else if ( noeud.getType().equals("travaux_pratiques") ) sel = 1;
         else if ( noeud.getType().equals("travaux_diriges") )   sel = 2;
         typeMenu = new JComboBox(types);
         typeMenu.setSelectedIndex(sel);
         contentPane.add(typeMenu);
      
         nomLabel = new JLabel();
         nomLabel.setText("Nom");
         contentPane.add(nomLabel);
      
         nomText = new JTextField(noeud.getNom(), 20); 
         contentPane.add(nomText);
      
         symboleLabel = new JLabel();
         symboleLabel.setText("Symbole");
         contentPane.add(symboleLabel);
      
         symText = new JTextField(noeud.getSymbole(), 20); 
         contentPane.add(symText);
      
         diffLabel = new JLabel();
         diffLabel.setText("Difficult");
         contentPane.add(diffLabel);
      
         String[] diffs = {"Dbutant", "Avanc", "Expert"};
         diffMenu = new JComboBox(diffs);
         diffMenu.setSelectedIndex(noeud.getDifficulte()-1); 
         contentPane.add(diffMenu);
      
         volumeLabel = new JLabel();
         volumeLabel.setText("Volume");
         contentPane.add(volumeLabel);
      
         String[] vols = {"1", "2", "3"};
         volumeMenu = new JComboBox(vols);
         volumeMenu.setSelectedIndex(noeud.getVolumeHoraire()-1); 
         contentPane.add(volumeMenu);
      
         zoomLabel = new JLabel();
         zoomLabel.setText("Zoom");
         contentPane.add(zoomLabel);
      
         zoomText = new JTextField(noeud.zoomer(), 20); 
         contentPane.add(zoomText);
      
         supportLabel = new JLabel();
         supportLabel.setText("Support");
         contentPane.add(supportLabel);
      
         String[] supports = {"http", "doc", "jpg"};
         supportMenu = new JComboBox(supports);
         supportMenu.setSelectedIndex(0);
         contentPane.add(supportMenu);
      
         urlLabel = new JLabel();
         urlLabel.setText("URL");
         contentPane.add(urlLabel);
      
         String url="";
         if ( noeud.getURL() != null ) url = noeud.getURL().toString();
         urlText = new JTextField(url, 20); 
         contentPane.add(urlText);
      
         okButton = new JButton();
         okButton.setText("OK");
         okButton.setActionCommand( "ok"); 
         okButton.addActionListener(this);
         contentPane.add(okButton);
      
         annulerButton = new JButton();
         annulerButton.setText("Annuler");
         annulerButton.setActionCommand( "annuler");
         annulerButton.addActionListener(this);
         contentPane.add(annulerButton);
      
      // Geometry management
         GridBagConstraints con = new GridBagConstraints();
         reset(con);
         con.gridx = 2;
         con.gridy = 1;
         con.gridwidth = 2;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(helloLabel, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 2;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(identLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 2;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.NONE;
         grid.setConstraints(identText, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 3;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(typeLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 3;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(typeMenu, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 4;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(nomLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 4;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(nomText, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 5;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(symboleLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 5;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.NONE;
         grid.setConstraints(symText, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 6;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(diffLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 6;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(diffMenu, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 7;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(volumeLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 7;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(volumeMenu, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 8;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(zoomLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 8;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(zoomText, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 9;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(supportLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 9;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(supportMenu, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 10;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(urlLabel, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 10;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.HORIZONTAL;
         grid.setConstraints(urlText, con);
      
         reset(con);
         con.gridx = 2;
         con.gridy = 11;
         con.ipadx = 40;
         con.insets = new Insets(10, 0, 10, 0);
         con.anchor = GridBagConstraints.WEST;
         con.fill = GridBagConstraints.NONE;
         grid.setConstraints(okButton, con);
      
         reset(con);
         con.gridx = 3;
         con.gridy = 11;
         con.insets = new Insets(10, 0, 10, 0);
         con.anchor = GridBagConstraints.EAST;
         con.fill = GridBagConstraints.NONE;
         grid.setConstraints(annulerButton, con);
      
      }
      
      
   /**
    * Donne tous les choix de la bote de dialogue.
    */   
      public String toString(){
         return ("Ident: "+choixIdent+" Type: "+choixType+" Nom: "+choixNom+" Symbole: "
                 +choixSymbole+" Zoom: "+choixZoom+"\nURL: "+choixURL+" Volume: "
                 +choixVolume+" Support: "+choixSupport+" Diff: "+choixDiff);
      }
   
   /**
    * La mthode vrifie si un indentificateur choisi pour un noeud existe dj.
    */
      protected boolean dejaNoeud(String str){
         Graphe graphe = (Graphe) frame.getGraphModel().getGraph();
         Vector noeuds = graphe.getVecteurNoeud();
         for (int i=0; i < noeuds.size() ; i++) {
            if ( str.equals( ((Noeud)noeuds.elementAt(i)).getIdent() ) ) 
            	return true;
            }
         return false;
      }
      
    /**
     * Prend les valeurs tapes dans la bote de dialogue.
     */  
      public void getValeurs(){
         choixIdent = identText.getText();
         choixType = (String)typeMenu.getSelectedItem();                                            
         choixNom = nomText.getText();                                            
         choixSymbole = symText.getText();                                          
         choixZoom = zoomText.getText();
         choixURL = urlText.getText();
         String volume = (String)volumeMenu.getSelectedItem();
         choixVolume = (new Integer(volume)).intValue();
         choixSupport = (String)supportMenu.getSelectedItem();
         String diff = (String)diffMenu.getSelectedItem();
         if (diff.equals("Dbutant")) choixDiff=1;
         else if (diff.equals("Avanc")) choixDiff=2;
         else if (diff.equals("Expert")) choixDiff=3;
      }
      
    /**
     * Les actions pour les deux bouttons "OK" et "Annuler".
     */     
      public void actionPerformed(ActionEvent e) {
         if (e.getActionCommand().equals("ok")) {
            getValeurs();
            if (choixIdent.equals("")){
               JOptionPane jop = new JOptionPane();
               jop.showMessageDialog(this,"Il faut spcifier un identificateur.","Warning",
                                     JOptionPane.ERROR_MESSAGE);
            }
            else{																// Modif D
               // si nouveau noeud avec ident dj existant						// Modif D
               //    ou modification d'ident en prenant un ident dj existant	// Modif D
               if (    ( !modifier & dejaNoeud(choixIdent) )					// Modif D
                    || ( modifier & dejaNoeud(choixIdent) 						// Modif D
                         & ( ! choixIdent.equals(noeud.getIdent()) ) )     ){	// Modif D
                  JOptionPane jop = new JOptionPane();
                  jop.showMessageDialog(this,"Un noeud avec l'identificateur "+choixIdent+
                  			" existe dj.\nChoisissez un autre!"
                  			,"Warning",JOptionPane.ERROR_MESSAGE);
               }
               else{
                  if (choixType.equals("Magistral")) noeud = new Noeud_M();
                  else if (choixType.equals("Travail dirig"))   noeud = new Noeud_TD();
                  else if (choixType.equals("Travail pratique")) noeud = new Noeud_TP();
                  noeud.setValeurs(choixIdent, choixNom, choixSymbole, choixSupport, 
                                   choixVolume, choixDiff, choixZoom, choixURL);
            
                 //"label" sera affich avec le noeud
                  noeud.setProperty("label", noeud.getIdent());
               
                  if (modifier) {
                     ((Graphe)frame.getGraphModel().getGraph()).modifierNoeud(noeudAModifier, noeud);
                     frame.getGraphView().changeNodeMapping(noeudAModifier, noeud);
                  }
                  else {
                  // Create a figure for it
                     Figure nf = frame.getGraphView().getNodeRenderer().render((Node)noeud);
                     nf.setInteractor(frame.getBasicGraphController().getNodeInteractor());
               
                     // Add to the view and model
                     frame.getGraphView().addNodeFigureToLayer(nf);
                     frame.getGraphView().placeNodeFigure(nf, nodeX, nodeY);
                     frame.getGraphView().addNodeMapping((Node)noeud, nf);
                     frame.getGraphModel().addNode((Node)noeud);
                  } 
               dispose();
               }
            }							// Modif D
         }
         else if (e.getActionCommand().equals("annuler")) {
            setVisible(false);
            dispose();
         }
      }
   
      private void reset(GridBagConstraints con) {
         con.gridx = GridBagConstraints.RELATIVE;
         con.gridy = GridBagConstraints.RELATIVE;
         con.gridwidth = 1;
         con.gridheight = 1;
      
         con.weightx = 0;
         con.weighty = 0;
         con.anchor = GridBagConstraints.CENTER;
         con.fill = GridBagConstraints.NONE;
      
         con.insets = new Insets(0, 0, 0, 0);
         con.ipadx = 0;
         con.ipady = 0;
      }
   }
