// *********************************************
// Modificications pour mise en libre :
// Modif C le 10/02/2000 par Marc Dauplait :
// pour la fonction de suppression de liens : Ajout d'un test dans la mthode "equals"
// *********************************************

   package carto.graphe;

   import java.awt.*;
   import java.awt.geom.*;

/**
 *  Lien Bidirectionnel, qui est en fait form de lien liens unidirectionnels plac entre les deux mmes noeuds et de sens opposs.
 */
   public class LienBiDir extends Lien
   {
    /**
     *  Premier lien undirectionnel qui compose le lien bidirectonnel
     */
      protected LienUniDir lien_1;
    /**
     *  Premier lien undirectionnel qui compose le lien bidirectonnel
     */
      protected LienUniDir lien_2;
   
    /**
     * Construit un lien bidirectionnel  partir de deux liens unidirectionnels
     * @param l_1 Premier lien unidirectionnel
     * @param l_2 Deuxime lien unidirectionnel
     */
      public LienBiDir(LienUniDir l_1, LienUniDir l_2)
      {
         super(l_1.getNoeudD(),l_1.getNoeudA());
         lien_1 = l_1;
         lien_2 = l_2;
      }
   
    /**
     *  Construit un lien bidirectionnel entre deux noeud
     * @param nD premier noeud
     * @param nA deuxime noeud
     */
      public LienBiDir(Noeud nD, Noeud nA)
      {
         super(nD,nA);
         lien_1 = new Lien_SANS(nD,nA);
         lien_2 = new Lien_SANS(nA,nD);
      }
   
    /**
     * Renvoie le premier lien unidirectionnel qui compose le lien bidirectionnel
     */
      public LienUniDir premier()
      {
         return lien_1;
      }
   
    /**
     *  Renvoie le deuxime lien unidirectionnel qui compose le lien bidirectionnel
     */
      public LienUniDir deuxieme()
      {
         return lien_2;
      }
   
      public String toString()
      { // @author Claudia
      	String resu="LienBiDir\n";
      	resu = resu + premier().getClass().toString()+" noeudD: "
      		+premier().getNoeudD().getIdent()+" noeudA: "+premier().getNoeudA().getIdent()+"\n";
      	resu = resu + deuxieme().getClass().toString()+" noeudD: "
      		+deuxieme().getNoeudD().getIdent()+" noeudA: "+deuxieme().getNoeudA().getIdent();
        return resu;
      }
   
      public  boolean equals(Lien l)
      {
         if ( !(l instanceof LienUniDir) ) {			// Modif C
            LienBiDir lb= (LienBiDir) l;
            if ( lb instanceof LienBiDir )
               return ((lien_1.equals(lb.lien_1)) && (lien_2.equals(lb.lien_2)));
         }												// Modif C
         return false;  
      }
   
      public boolean noeudsEquals(LienBiDir l)
      {
      
         return ((super.equals(l.lien_1)) &&
                    (super.equals(l.lien_2)));
      }
   
      public void paint(Graphics g)
      {
         lien_1.paint(g);
         lien_2.paint(g);
      }
   
    /**
     * Renvoie le type du Lien Unidirectionel
     */
      public String getType()
      {
         return "";
      }
   
    /**
     * Renvoie le niveau de  difficulte du lien
     * @return le niveau de difficulte du lien
     */
      public int getDifficulte()
      {
         return 0;
      }
   
    /**
     *Renvoie l'epaisseur pour dessiner le lien
     *@return l'epaisseur pour tous les liens unidirectionnels
     *l'epaisseur peut etre: 1, 2, ou 3
     */
      public float getDefautEpaisseur()
      {
         return 1.0f;
      }
    /**
     *Renvoie la couleur pour dessiner le lien
     *@return la couleur pour tous les liens unidirectionnels
     */
      public Color getDefautCouleur()
      {
         return Color.black;
      }
   }
