package carto.graphe;

import carto.dessin.*;  
import java.awt.*;
import java.awt.geom.*;

/**
 *  Cette classe correspond  un lien contenu dans un chemin.
 */

public class LienChemin extends Lien
{
    /**
     *  Construit un lien de chemin entre deux noeuds
     *  @param nD Noeud de dpart
     *  @param nA Noeud d'arrive
     */
    public LienChemin(Noeud nD, Noeud nA)
    {
	super(nD,nA);
	dessin = new LigneChemin(this, getTrace());
	dessin.setCouleur(getDefautCouleur());
    }
    
    /**
     *Renvoie l'intervalle de la trace pour dessiner le lien
     *@return le type de trace pour tous les lienChemin
     */
    public float[] getTrace()
    {
	float[] intervalle = {7.0f};
	return intervalle;
    }
 
    /**
     *Renvoie l'intervalle de la trace pour dessiner la fleche du lien
     *@return le type de trace pour tous les fleches de lienChemin
     */   
    public float[] getTraceFleche()
    {
	float[] intervalle = {0.0f};
	return intervalle;
    }
    
    /**
     * @return L'epaiiseur du lien
     */
    public float getDefautEpaisseur()
    {
	return 3.0f;
    }

    /**
     *  Change la couleur du lien.
     * @param c La nouvelle couleur du lien
     */ 
    public void changerCouleur(Color c) 
    {
	dessin.setCouleur(c);
    }

    /**
     *  Renvoie la couleur du lien
     */    
    public Color getDefautCouleur()
    {
	return Color.blue;
    }
    
    /**
     *  Renvoie le type du lien
     */
    public String getType()			
    {
	return "";
    }

    public boolean equals(Lien l)
    {
	LienChemin lc;
	if ( l instanceof LienChemin )
	    {
		lc=(LienChemin)l;
		return ((noeudD.equals(lc.getNoeudD()) && 
			 noeudA.equals(lc.getNoeudA())));
	    }
	return false;
    }

    public void paint(Graphics g)
    {
	dessin.etablirDessin();
	dessin.paint(g);
    }  
}
