   package carto.graphe;

   import carto.dessin.*;

   import java.util.Vector;
   import java.awt.Frame;
   import java.awt.Color;
   import java.awt.Graphics;

   /**Cette classe montre l'utilisation de la plupart des composants du 
   * paquetage 'carto.graphe'. Le constructeur cre de noeuds, des liens et
   * un chemin. Les composants sont ajouts au 'Graphe' et puis dessins.
   */

   public class Tutorial extends Frame
   {
      static Graphe graphe = new Graphe();
      Noeud n1,n2,n3,n4,n5, n6;
      LienUniDir l1,l2,l3,l4; 
      Lien l5,l6,l7,l8;
      Fleche fleche ;  
      LienChemin lc,lc1,lc2,lc3,lc4;
      Chemin chemin;
      static Vector vecteur, vectLienCh;
      int cont =0;
   
      public Tutorial()
      {
         setSize(500,500);
         setBackground(Color.white);
         setTitle("Test-Graphe");
      
         n1= new Noeud_M();
         n2= new Noeud_TP();
         n3= new Noeud_TD();
         n4= new Noeud_TP();
         n5= new Noeud_M();
      
         n1.setCoordX(50);
         n1.setCoordY(120);
         n2.setCoordX(200);
         n2.setCoordY(100);
         n3.setCoordX(300);
         n3.setCoordY(200);
         n4.setCoordX(230);
         n4.setCoordY(300);
         n5.setCoordX(100);
         n5.setCoordY(300);
      
         n1.setIdent("1"); 
         n2.setIdent("2"); 
         n3.setIdent("3"); 
         n4.setIdent("4"); 
         n5.setIdent("5");
      
         n1.setSymbole("nodo1");
         n1.setNom("curso1");
         n2.setSymbole("nodo2");
         n2.setNom("curso2");
         n3.setSymbole("nodo3");
         n3.setNom("curso3");
         n4.setSymbole("nodo4");
         n4.setNom("curso4");
      
         l1= new Lien_T(n1,n2);
         l2= new Lien_PO(n2,n3);
         l3= new Lien_CA(n1,n3);
         l4= new Lien_T(n1,n4);
      
         l5= new LienBiDir(n2,n4);
         l6= new Lien_T(n3,n4);
         l7= new Lien_PO(n4,n3);
         l8= new LienBiDir((LienUniDir)l6,(LienUniDir)l7);
         ((LienBiDir)l8).premier().setDifficulte(3);
         ((LienBiDir)l8).deuxieme().setDifficulte(1);
      
      
         lc1= new LienChemin(n1,n2);
         lc2= new LienChemin(n2,n3);
         lc3= new LienChemin(n3,n4);
         lc4= new LienChemin(n4,n5);
      
         graphe.ajouterNoeud(n1);
         graphe.ajouterNoeud(n2);
         graphe.ajouterNoeud(n3);
         graphe.ajouterNoeud(n4);
         graphe.ajouterNoeud(n5);
         cont=graphe.ajouterLienUni(l1); 
         cont=graphe.ajouterLienUni(l2);
         cont=graphe.ajouterLienUni(l3); 
         cont=graphe.ajouterLienUni(l4);
         cont=graphe.ajouterLienBi((LienBiDir)l5);
         cont=graphe.ajouterLienBi((LienBiDir)l8); 
      
         chemin = new Chemin (1, "chemin",graphe);
         cont=chemin.ajouterLienChemin(lc1);
         cont=chemin.ajouterLienChemin(lc2);
         cont=chemin.ajouterLienChemin(lc3);
         cont=chemin.ajouterLienChemin(lc4);
         graphe.setChemin(chemin);  
      
         n6=new Noeud_M();
         n6.setValeurs("test","curso6","nodo6","html",3,3,null,null);
         graphe.modifierNoeud(n4,n6);
         System.out.println(graphe.toString());
         
         graphe.supprimerNoeud(n6);
         //graphe.supprimerNoeud(n2);
         //graphe.supprimerNoeud(n2);
         //graphe.supprimerNoeud(n6);
         //System.out.println(graphe.toString());
      
         repaint(); //java.awt.Component
      }
   
   
      public void paint(Graphics g)
      {
         graphe.paint(g);
      }
   
      public static void main(String argv[])
      {
         Tutorial tut = new Tutorial();
         tut.show(); //java.awt.Component
      }
   }
