// *********************************************
// Modificications pour mise en libre :
// Modif E le 29/02/2000 par Marc Dauplait :
// Lgres modifs pour rendre le Handler compatible avec le parser XP (http://www.jclark.com/xml/xp/)
// meta.setDateCreation dplac dans endElement et diffrentiation des balises de fin dans endElement
// Modif F le 13/06/2000 par Marc Dauplait :
// Quelques modifications d'interfaces pour compatibilite SAX2 et parser XERCES
// *********************************************

   package carto.parse;

   import org.xml.sax.helpers.DefaultHandler;			// Modif F
   import org.xml.sax.Attributes;						// Modif F
   import org.xml.sax.SAXParseException;
   import org.xml.sax.SAXException;

   import java.util.GregorianCalendar;
   import java.net.URL;
   import java.util.Vector;
   import java.text.DateFormat;

   import carto.graphe.*;
   import carto.parse.GrapheParser;

/** 
 * Cette classe hrite de 'org.xml.sax.DefaultHandler'. Elle reoit des notification
 * des balises d'un fichier .xml. Elle spcifie le traitement des balises du 
 * fichier graphe.dtd. Elle cre l'instance de la classe 'carto.graphe.Graphe'.
 * Cette classe lance des exceptions si l'identifier d'un noeud n'est pas spcifi ou existe dj, 
 * si le noeud de dpart ou d'arrive d'un lien n'existent pas dans le graphe et si 
 * le noeud de dpart et d'arrive d'un lien sont pareils.
 */

   public class ParseHandler extends DefaultHandler				// Modif F
   {
      GregorianCalendar calendrier=new GregorianCalendar();
      MetaGraphe meta;
      Noeud noeud, nD, nA;
      LienUniDir l;
      LienChemin lc;
      Vector vecteurLienChemin;
      Chemin chemin;
      String balise, nomChemin;
      int valeur=0;
      protected static Graphe graphe;
   
      public ParseHandler()										// Modif F
      {
         super();
      }
   
      public void startElement (String uri, String name, String qName, Attributes atts) // Modif F
      {
         balise=name;
         if (name.equals("Meta")) meta = new MetaGraphe();
         else if (name.equals("Noeud")) noeud = new Noeud_M(); 
         else if (name.equals("Lien") || name.equals("LienChemin")){
            nD = new Noeud_M();
            nA = new Noeud_M();
         }
         else if (name.equals("Chemin")){
            vecteurLienChemin = new Vector();
         }
      }
   
      public void characters(char[] ch, int start, int length)  throws SAXException
      {
         String contenu = "";
         for (int i=start; i<(start+length); i++)
            contenu = contenu + ch[i];

         //System.out.println("balise="+balise+" longueur="+length+" contenu="+contenu+"\n");

      ////////////////////////////////////////////////////////////
      ///////////contenu de la classe MetaGraphe/////////////////
         if(balise.equals("Titre"))    meta.setTitre(contenu);
         else if(balise.equals("Createur")) meta.setCreateur(contenu);
         else if(balise.equals("MotsCles")) meta.setMotsCles(contenu);
         else if(balise.equals("Pere"))     meta.setPere(contenu);
         else if(balise.equals("Version"))  meta.setVersion(contenu);
         else if(balise.equals("Niveau"))  
         {
            valeur = (new Integer(contenu)).intValue();   
            switch (valeur)
            { 
               case 1:
               case 2:
               case 3:
               case 4:
               case 5: 
                  meta.setNiveau(valeur);
                  break;
               default: 
                  meta.setNiveau(1);
                  break;
            }
         }
         else if(balise.equals("An")) 
         {
            valeur = (new Integer(contenu)).intValue();   
            calendrier.set(calendrier.YEAR,valeur);
         }
         else if(balise.equals("Mois"))
         {
            valeur = (new Integer(contenu)).intValue();
            calendrier.set(calendrier.MONTH,valeur-1);
         }
         else if(balise.equals("Jour")) 
         {
            valeur = (new Integer(contenu)).intValue();
            calendrier.set(calendrier.DAY_OF_MONTH,valeur);
         }
         //meta.setDateCreation(calendrier);	//dplac dans mthode endElement	// Modif E
         
      ////////////////////////////////////////////////////////////
      ///////////contenu de la classe Noeud///////////////////////
         if (balise.equals("TypeN"))
         {
            if (contenu.equals("M"))  noeud = new Noeud_M();
            else if (contenu.equals("TD")) noeud = new Noeud_TD();
            else if (contenu.equals("TP")) noeud = new Noeud_TP();
         }
         else if (balise.equals("Ident"))   
            if ( graphe.getNoeud(contenu) != null )
               throw new SAXException("Noeud avec identifier "+contenu
                                      +" existe dj dans le graphe."+debug());
            else
               noeud.setIdent(contenu);
         
         else if (balise.equals("Nom"))     noeud.setNom(contenu);
         else if (balise.equals("Symbole")) noeud.setSymbole(contenu);
         else if (balise.equals("Support")) noeud.setSupport(contenu);
         else if (balise.equals("URL"))     noeud.setURL(contenu);
         else if (balise.equals("Volume")) 
         {
            valeur = (new Integer(contenu)).intValue();   
            switch (valeur)
            { 
               case 1:
               case 2:
               case 3: 
                  noeud.setVolumeHoraire(valeur);
                  break;
               default: 
                  noeud.setVolumeHoraire(2);
                  break;
            }
         }
         else if (balise.equals("Difficulte")) 
         {
            valeur = (new Integer(contenu)).intValue();   
            switch (valeur)
            {  
               case 1:
               case 2:
               case 3: 
                  noeud.setDifficulte(valeur);
                  break;
               default: 
                  noeud.setDifficulte(2);
                  break;
            }
         }
         else if (balise.equals("CoordX")) 
         {
            valeur = (new Integer(contenu)).intValue();
            noeud.setCoordX(valeur);
         }
         else if (balise.equals("CoordY")) 
         {
            valeur = (new Integer(contenu)).intValue();
            noeud.setCoordY(valeur);
         }
         // le test si le 'zoom' est bien un fichier existant 
         // est fait dans l'applet 
         else if (balise.equals("Zoom")) noeud.setGraphe(contenu);
         
         
         ////////////////////////////////////////////////////////////
         ///////////contenu de la classe Lien////////////////////////
         else if (balise.equals("noeudD"))
         {
            if ( graphe.getNoeud(contenu) == null )
               throw new SAXException("Noeud avec identifier "+contenu
                                      +" n'existe pas dans le graphe."+debug());
            else
               nD=graphe.getNoeud(contenu);
         }
         else if (balise.equals("noeudA"))
         {
            if ( graphe.getNoeud(contenu) == null )
               throw new SAXException("Noeud avec identifier "+contenu
                                      +" n'existe pas dans le graphe.");
            else if ( nD == graphe.getNoeud(contenu) )
               throw new SAXException("Le noeud de dpart et le noeud d'arrive sont indentiques."+debug());
            else
               nA=graphe.getNoeud(contenu);
         }
         else if (balise.equals("TypeL"))
         {
            if (contenu.equals(""))   l = new Lien_SANS(nD,nA);
            else if (contenu.equals("CA")) l = new Lien_CA(nD,nA);
            else if (contenu.equals("T"))  l = new Lien_T(nD,nA);
            else if (contenu.equals("PO")) l = new Lien_PO(nD,nA);
            else if (contenu.equals("D"))  l = new Lien_D(nD,nA);
            else if (contenu.equals("CO")) l = new Lien_CO(nD,nA);
         }
         else if (balise.equals("Diff"))
         {
            valeur = (new Integer(contenu)).intValue();
            switch (valeur)
            { 
               case 1:
               case 2:
               case 3: 
                  l.setDifficulte(valeur);
                  break;
               default: 
                  l.setDifficulte(2);
                  break;
            }
         }
         
         ////////////////////////////////////////////////////////////
         ///////////contenu de la classe LienChemin//////////////////	
         else if (balise.equals("NoeudD"))
         {
            if ( graphe.getNoeud(contenu) == null )
               throw new SAXException("Noeud avec identifier "+contenu
                                      +" n'existe pas dans le graphe"+debug());
            else
               nD=graphe.getNoeud(contenu);
         }
         else if (balise.equals("NoeudA"))
         {
            if ( graphe.getNoeud(contenu) == null )
               throw new SAXException("Noeud avec identifier "+contenu
                                      +" n'existe pas dans le graphe"+debug());
            else if ( nD == graphe.getNoeud(contenu) )
               throw new SAXException("Le noeud de dpart et le noeud d'arrive sont indentiques."+debug());
            else
               nA=graphe.getNoeud(contenu);
         }         
         else if (balise.equals("NomChemin")) 
            nomChemin = new String(contenu);
         else if (balise.equals("Cours"))
            valeur= (new Integer(contenu)).intValue();
      }



   
      public void endElement (String uri, String name, String qName) throws SAXException // Modif F
      {  
         // System.out.println("Balise fermante: "+name);
         
         balise = "/"+name;													// Modif E
         
         if (name.equals("Meta")) graphe.ajouterMetaGraphe(meta);
         
         else if (name.equals("Date")) meta.setDateCreation(calendrier);	// Modif E
         
         else if (name.equals("Noeud")) 
         {
            if( noeud.getIdent() == "" )
               throw new SAXException("Identifieur d'un noeud n'est pas spcifi"+debug());
            else
               graphe.ajouterNoeud(noeud); 
         }
         
         else if (name.equals("Lien")) 
         {	
            graphe.ajouterLienUni(l);
         }
         
         else if (name.equals("Chemin")) 
         {
            chemin = new Chemin(valeur, nomChemin, graphe);
            for (int i=0;i<vecteurLienChemin.size();i++)
            {
               lc=(LienChemin) vecteurLienChemin.elementAt(i);
               int k=chemin.ajouterLienChemin(lc);
            }
            graphe.setChemin(chemin);
         }
         
         else if (name.equals("LienChemin")) 
         {
            lc= new LienChemin(nD,nA);
            vecteurLienChemin.add(lc);
         }
         //System.out.println(chemin.toString());
      }
   
    /**
     * Donne le fichier, la ligne et la colonne de l'erreur.
     */
      public void error(SAXParseException e) {
         System.out.println("Erreur pendant le parsing:\nfichier: "+e.getSystemId()+
                            " ligne :"+e.getLineNumber()+
                            " colonne :"+e.getColumnNumber()); 
      }
   
    /**
     * Donne le fichier, la ligne et la colonne de l'erreur.
     */
      public void fatalError(SAXParseException e) {
      
         System.out.println("Erreur pendant le parsing:\nfichier: "+e.getSystemId()+
                            " ligne :"+e.getLineNumber()+
                            " colonne :"+e.getColumnNumber()); 
      }
   
    /**
     * Donne le fichier, la ligne et la colonne du warning.
     */
      public void warning(SAXParseException e) {
      
         System.out.println("Warning pendant le parsing:\nfichier: "+e.getSystemId()+
                            " ligne :"+e.getLineNumber()+
                            " colonne :"+e.getColumnNumber()); 
      }
   
      protected String debug()
      {
         return "" /*+locator.getSystemId()+			// Modif F
            "\nligne : "+locator.getLineNumber()+
            " colonne : "+locator.getColumnNumber()*/; 
      }
   
      public void startDocument()
      {
         graphe = new Graphe();
      }
   
      public Graphe getGraphe(){
         return graphe;
      }
   
      public void endDocument()
      {}
   
   }

