// *********************************************
// Modificications pour mise en libre :
// Modif A le 27/01/2000 par Marc Dauplait :
// Simple ajout de commentaires
// Modif F le 14/06/2000 par Marc Dauplait :
// Fixe d'un bug apparu avec SAX2
// *********************************************

   package carto.rmi;

   import java.rmi.*;
   import java.rmi.server.*;
   import java.rmi.registry.LocateRegistry;

   import java.io.*;

   import carto.graphe.*;

   public class FichierImpl extends UnicastRemoteObject
   implements Fichier
   {
      private String fichier;
      private int port = 1099;
   
      public FichierImpl() throws RemoteException {
         super();
         try { 
            // Lance le Registry sur la machine locale (le serveur)
            LocateRegistry.createRegistry(port); 
            System.out.println("Enregistrement sur le port " + port);
            // Bind cette instance de FichierImpl dans le Registry sous le nom de "Fichier"
            Naming.rebind("Fichier", this); 
            System.out.println("'Fichier' bound in registry"); 
         } 
            catch (Exception e) { 
               System.out.println("FichierImpl err: " + e.getMessage()); 
               e.printStackTrace(); 
            }
      }
   /** La mthode transforme le contenu du ficher 'unFichier' en 
    *  String pour le transmettre via 'rmi' au client demandant.
    *  @return la rprsentation String du fichier
    *  @param unFichier le nom/ le rpertoire d'un fichier
    */       
      public String getFichier(String unFichier) throws IOException,FileNotFoundException
      {
      //on cree un 'DataInputStream' a partir du fichier
      //on le lit ligne par ligne dans un String
         String source="";										// Modif F
      //try
      //   {	
      
         System.out.println("Demande de lecture du fichier : " + unFichier);
      
         DataInputStream in = new DataInputStream(new BufferedInputStream(new FileInputStream (unFichier)));
         String s = new String ();
         while ((s = in.readLine())!= null)
            source += s + "\n";
         in.close();
         //    }
         //catch (Exception e)
         //{
         //System.out.println("FichierImpl.getFichier err: " + e.getMessage()); 
         //e.printStackTrace();
         //}
         return source;
      }      
   
      public static void main(String[] args) {
         if (System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());
         }
         try {
            FichierImpl fichier = new FichierImpl();
            System.out.println("FichierServer bound");
         } 
            catch (Exception e) {
               System.err.println("FichierImpl exception: " + e.getMessage());
               e.printStackTrace();
            }
      }
   }
