/*

 * $Id: GrabHandleFactory.java,v 1.1.1.1 2000/05/15 22:11:04 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved. See the file COPYRIGHT for details.

 */

package diva.canvas.manipulator;



import diva.canvas.Site;



/**

 * A factory so that a client can create grab handles without

 * knowing anything about their implementation.

 *

 * @author Michael Shilman  (michaels@eecs.berkeley.edu)

 * @version	$Revision: 1.1.1.1 $

 */

public interface GrabHandleFactory {

    /** Create a grab-handle that is attached to the given

     * site. The grab-handle will be located so that its

     * attachment point is at the site.

     */

    public GrabHandle createGrabHandle (Site s);

}

