/*

 * $Id: ShapedFigure.java,v 1.1.1.1 2000/05/15 22:11:05 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved. See the file COPYRIGHT for details.

 */

package diva.canvas.manipulator;

import diva.canvas.Figure;

import java.awt.Shape;



/**

 * An interface that defines the setShape() method. This method must

 * be implemented by any figure that can have a PathManipulator

 * wrapped around it.

 *

 * @author John Reekie      (johnr@eecs.berkeley.edu)

 * @version $Revision: 1.1.1.1 $

 */

public interface ShapedFigure extends Figure {

    /**

     * Set the shape of this figure. This method is used by

     * PathManipulators to implement reshaping of figures.

     */

    public void setShape (Shape s);

}

