/*

 * $Id: BasicEdgeRenderer.java,v 1.1.1.1 2000/05/15 22:11:06 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved.  See the file COPYRIGHT for details.

 */

package diva.graph;

import diva.graph.model.Edge;

import diva.canvas.Site;

import diva.canvas.connector.Connector;

import diva.canvas.connector.StraightConnector;

import diva.canvas.connector.Arrowhead;



/**

 * A basic implementation of the EdgeRenderer interface.

 * This renderer creates straight-line connectors with

 * an arrow at the head.

 *

 * @author Michael Shilman  (michaels@eecs.berkeley.edu)

 * @version $Revision: 1.1.1.1 $

 * @rating Red

 */

public class BasicEdgeRenderer implements EdgeRenderer {

    /**

     * Render a visual representation of the given edge.

     */

    public Connector render(Edge edge, Site tailSite, Site headSite) {

        StraightConnector c = new StraightConnector(tailSite, headSite);

        Arrowhead arrow = new Arrowhead(

                headSite.getX(), headSite.getY(), headSite.getNormal());

        c.setUserObject(edge);

        c.setHeadEnd(arrow);

        return c;

    }

}

