/*

 * $Id: EdgeInteractor.java,v 1.1.1.1 2000/05/15 22:11:06 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved.  See the file COPYRIGHT for details.

 */

package diva.graph;



import diva.canvas.*;

import diva.canvas.event.*;

import diva.canvas.selection.*;

import java.awt.event.*;



/**

 * An interactor for edges.

 *

 * @author 	Michael Shilman (michaels@eecs.berkeley.edu)

 * @author 	John Reekie (johnr@eecs.berkeley.edu)

 * @version	$Revision: 1.1.1.1 $

 * @rating Red

 */

public class EdgeInteractor extends SelectionInteractor {



    /** The controller that this interactor is a part of

     */

    private GraphController _controller;



    /** Create a new edge interactor that belongs to the given

     * controller.

     */

    public EdgeInteractor (GraphController c) {

       super();

        _controller = c;

    }



    /** Create a new edge interactor that belongs to the given

     * controller and that uses the given selection model

     */

    public EdgeInteractor (GraphController c, SelectionModel sm) {

        this(c);

        super.setSelectionModel(sm);

    }

}

