/*

 * $Id: GraphController.java,v 1.1.1.1 2000/05/15 22:11:06 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved.  See the file COPYRIGHT for details.

 */

package diva.graph;



import diva.graph.layout.*;

import diva.graph.model.*;

import diva.canvas.*;

import diva.canvas.event.*;

import diva.canvas.selection.*;

import diva.canvas.toolbox.*;

import java.awt.geom.*;

import java.util.*;

import diva.util.*;



/**

 * An interface that defines the role of graph controller.

 *

 * @author 	Michael Shilman (michaels@eecs.berkeley.edu)

 * @version	$Revision: 1.1.1.1 $

 * @rating      Red

 */

public interface GraphController extends GraphListener {

    /**

     * Get the interactor given to edge figures.

     */

    public EdgeInteractor getEdgeInteractor ();



    /**

     * Get the interactor given to node figures.

     */

    public NodeInteractor getNodeInteractor ();



    /**

     * Get the model that this controller operates on.

     */

    public GraphModel getGraphModel ();



    /**

     * Get the view that this controller operates on. This is intended

     * for initialization only.

     */

    public GraphView getGraphView ();



    /**

     * Set the view that this controller operates on. This is intended

     * for initialization only.

     */

    public void setGraphView (GraphView view);



    /**

     * Set the model that this controller listens to.  This is intended

     * for initialization only.

     */

    public void setGraphModel (GraphModel model);

}

