/*

 * $Id: ArcRenderer.java,v 1.1.1.1 2000/05/15 22:11:06 dauplait Exp $

 *

 * Copyright (c) 1999 The Regents of the University of California.

 * All rights reserved.  See the file COPYRIGHT for details.

 */

package diva.graph.bubble;



import diva.graph.model.Edge;

import diva.graph.EdgeRenderer;

import diva.canvas.Site;

import diva.canvas.connector.Connector;

import diva.canvas.connector.ArcConnector;

import diva.canvas.connector.StraightConnector;

import diva.canvas.connector.Arrowhead;



import java.awt.Font;



/**

 * An EdgeRenderer that draws arcs. To do so, it creates a new

 * instance of ArcConnector and initializes it.

 *

 * @author Edward A. Lee  (eal@eecs.berkeley.edu)

 * @version $Revision: 1.1.1.1 $

 * @rating Red

 */

public class ArcRenderer implements EdgeRenderer {



    /** Render a visual representation of the given edge.

     */

    public Connector render(Edge edge, Site tailSite, Site headSite) {

        // FIXME: Find a way to set the curvature (the third argument).

        StraightConnector c = new StraightConnector(tailSite, headSite);

        Arrowhead arrow = new Arrowhead(

                headSite.getX(), headSite.getY(), headSite.getNormal());

        c.setUserObject(edge);

        c.setHeadEnd(arrow);



        Object p = edge.getProperty("label");

        String label = p == null ? "#" : (String) p;

        c.setLabel(label);

        c.getLabelFigure().setStyle(Font.ITALIC);

        c.getLabelFigure().setSize(14);



        return c;

    }

}

