/*

 * $Id: IncrementalLayout.java,v 1.1.1.1 2000/05/15 22:11:07 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved.  See the file COPYRIGHT for details.

 */

package diva.graph.layout;



/**

 * A layout engine which operates incrementally,

 * based on the arrival of new node information.

 *

 * @author Michael Shilman  (michaels@eecs.berkeley.edu)

 * @version $Revision: 1.1.1.1 $

 * @rating Red

 */

public interface IncrementalLayout extends diva.graph.model.GraphListener {

    /**

     * Return whether this layout engine uses

     * timeout event cues for when to perform

     * layout.

     *

    public boolean usesTimeout();

     */



    /**

     * Set whether this layout engine should

     * use timeout event cues for when to

     * perform layout.

     *

    public void useTimeout(boolean val);

     */



    /**

     * A timeout event has occurred.

     *

    public void timeout()

     */





    /**

     * Layout the graph

     *

    public void layout(LayoutInfo l)

     */

    //XXX more here

}

