/*

 * $Id: BasicEdgeSet.java,v 1.1.1.1 2000/05/15 22:11:07 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved.  See the file COPYRIGHT for details.

 */

package diva.graph.model;

import java.util.Iterator;

import java.util.ArrayList;

import diva.util.ArrayIterator;



/**

 * A basic collection of edges used internally

 * by BasicNode.

 *

 * @author John Reekie      (johnr@eecs.berkeley.edu)

 * @author Michael Shilman  (michaels@eecs.berkeley.edu)

 * @version $Revision: 1.1.1.1 $

 * @rating Yellow

 */

public class BasicEdgeSet {

    /**

     * The edge references

     */

    ArrayList _edges = new ArrayList();



    /**

     * An empty edge set.

     */

    public BasicEdgeSet() {

    }



    public void add (Edge e) {

        _edges.add(e);

    }



    public void clear () {

        //detach all the edges; they will

        //remove themselves from this

        //edge set.

        while(_edges.size() > 0) {

            BasicEdge e = (BasicEdge)_edges.get(0);

            e.detach();

        }

    }



    public boolean contains(Edge e) {

        return _edges.contains(e);

    }



    public Iterator edges() {

        return (new ArrayIterator(_edges.toArray()));

    }



    public void remove(Edge e) {

        _edges.remove(e);

    }

}

