/*
 * $Id: BasicGraphImpl.java,v 1.1.1.1 2000/05/15 22:11:07 dauplait Exp $
 *
 * Copyright (c) 1998 The Regents of the University of California.
 * All rights reserved.  See the file COPYRIGHT for details.
 */
   package diva.graph.model;
	import carto.graphe.*;

/**
 * A graph implementation which creates and edits elements of the type
 * BasicCompositeNode, BasicNode, BasicGraph, and BasicEdge
 * respectively.
 *
 * @author Michael Shilman  (michaels@eecs.berkeley.edu)
 * @version $Revision: 1.1.1.1 $
 * @rating Yellow
 */
   public class BasicGraphImpl implements GraphImpl {
   
    /**
     * Add a node to the given graph.
     */
      public final void addNode(Node n, Graph parent) {
         Noeud noeud = (Noeud)n;
      
         //if(parent instanceof BasicCompositeNode) {
         //   ((BasicCompositeNode)parent).add(noeud);
         //}
         //else {
            ((Graphe)parent).add(noeud);
         //}
      }
      
   /**
     * Add a edge to the given graph.
     */
      public final void addEdge(Edge e, Graph parent) {
         Lien lien = (Lien)e;
         ((Graphe)parent).addEdge(lien);
      }
      
    /**
     * Return a new instance of a BasicCompositeNode with the given
     * semantic object.
     */
      public CompositeNode createCompositeNode(Object semanticObject) {
         CompositeNode n = new BasicCompositeNode();
         n.setSemanticObject(semanticObject);
         return n;
      }
   
    /**
     * Return a new instance of a BasicNode with the given semantic
     * object.
     */
      public final Node createNode(Object semanticObject) {
         Node n = new Noeud_M();
         n.setSemanticObject(semanticObject);
         return n;
      }
   
    /**
     * Return a new instance of a BasicGraph with the given semantic
     * object.
     */
      public final Graph createGraph(Object semanticObject) {
         Graphe g = new Graphe();
         //g.meta.setTitre("Le nouveau graphe");
         return (Graph) g;
      }
   
    /**
     * Return a new instance of a BasicEdge with the given semantic
     * object.
     */
      public final Edge createEdge(Object semanticObject) {
         Edge e = new LienUniDir();
         e.setSemanticObject(semanticObject);
         return e;
      }
   
   
    /**
     * Remove a node from the given graph.
     */
      public final void removeNode(Node n) {
         Noeud bn = (Noeud)n;
         Graphe parent = (Graphe)bn.getParent();
      
         if(parent == null) {
            String err = "Trying to remove node with no parent";
            throw new GraphException(err);
         }
      
         if((Graph)parent instanceof BasicCompositeNode) {
            ((BasicCompositeNode)((Graph)parent)).delete(bn);
         }
         else {
            ((Graphe)parent).delete(bn);
         }
      }
   
    /**
     * Set the edge's head to the given node.
     */
      public final void setEdgeHead(Edge e, Node head) {
         Lien l = (Lien)e;
         Noeud n = (Noeud)head;
         l.setHead(n);
      }
   
    /**
     * Set the edge's tail to the given node.
     */
      public final void setEdgeTail(Edge e, Node tail) {
         Lien l = (Lien)e;
         Noeud n = (Noeud)tail;
         l.setTail(n);
      }
   }
