/*

 * $Id: Graph.java,v 1.1.1.1 2000/05/15 22:11:07 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved.  See the file COPYRIGHT for details.

 */

package diva.graph.model;

import java.util.Iterator;

import diva.util.SemanticObjectContainer;

import diva.util.PropertyContainer;



/**

 * A minimal interface to a collection of nodes and edges

 * which can be annotated with a user object and arbitrary properties.

 *

 * @author Michael Shilman  (michaels@eecs.berkeley.edu)

 * @author John Reekie      (johnr@eecs.berkeley.edu)

 * @version $Revision: 1.1.1.1 $

 * @rating Yellow

 */

public interface Graph extends SemanticObjectContainer, PropertyContainer {

    /**

     * Return true if this graph contains the given node.

     */

    public boolean contains(Node n);



    /**

     * Return the number of nodes contained in

     * this graph.

     */

    public int getNodeCount();



    /**

     * Provide an iterator over the nodes in this

     * graph.  This iterator does not support removal

     * operations.

     */

    public Iterator nodes();

}

