/*

 * $Id: GraphException.java,v 1.1.1.1 2000/05/15 22:11:07 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved.  See the file COPYRIGHT for details.

 */



package diva.graph.model;



/**

 * A graph package topological error.  GraphException is

 * a RuntimeException so that the code is not unnecessarily

 * cluttered with try/catch blocks around every graph

 * operation, the same way that ArrayOutOfBounds exceptions

 * do not need to be caught at every array access.

 *

 * @author Michael Shilman (michaels@eecs.berkeley.edu)

 * @version $Revision: 1.1.1.1 $

 * @rating Yellow

 */

public class GraphException extends RuntimeException {

    public GraphException() {

        super();

    }

    public GraphException(String s) {

        super(s);

    }

}

