/*

 * $Id: IndexedGraph.java,v 1.1.1.1 2000/05/15 22:11:07 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved.  See the file COPYRIGHT for details.

 */

package diva.graph.model;



/**

 * A more specific version of the graph interface

 * which exposes a node ordering.

 *

 * @author Michael Shilman (michaels@eecs.berkeley.edu)

 * @version $Revision: 1.1.1.1 $

 * @rating Yellow

 */

public interface IndexedGraph extends Graph {

    /**

     * Return the index of the given node,

     * or -1 if the node is not contained by

     * this graph.

     */

    public int getIndex(Node n);



    /**

     * Return the node at the given index, or

     * throw an IndexOutOfBoundsException if the

     * index is invalid.

     */

    public Node getNode(int index);

}

