/*

 * $Id: PropertyContainer.java,v 1.1.1.1 2000/05/15 22:11:08 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved.  See the file COPYRIGHT for details.

 */

package diva.util;



/**

 * An object that can be annotated with arbitrary

 * objects whose keys are strings.

 *

 * @author Michael Shilman (michaels@eecs.berkeley.edu)

 * @version $Revision: 1.1.1.1 $

 */

public interface PropertyContainer {

    /**

     * Return the property corresponding to

     * the given key, or null if no such property

     * exists.

     */

    public Object getProperty(String key);



    /**

     * Set the property corresponding to

     * the given key.

     */

    public void setProperty(String key, Object value);



    // XXX removeProperty

}

