/*

 * $Id: UnitIterator.java,v 1.1.1.1 2000/05/15 22:11:08 dauplait Exp $

 *

 * Copyright (c) 1998 The Regents of the University of California.

 * All rights reserved.  See the file COPYRIGHT for details.

 */

package diva.util;



import java.util.Iterator;

import java.util.NoSuchElementException;



/**

 * An iterator over a single object.

 *

 * @author John Reekie      (johnr@eecs.berkeley.edu)

 * @author Michael Shilman  (michaels@eecs.berkeley.edu)

 * @version $Revision: 1.1.1.1 $

 */

public class UnitIterator implements Iterator {

    private Object _item = null;



    public UnitIterator(Object item) {

        _item = item;

    }



    public boolean hasNext() {

        return _item != null;

    }

    

    public Object next() {

        if (_item != null) {

            Object item = _item;

            _item = null;

            return item;

        } else {

            throw new NoSuchElementException("No more elements");

        }

    }

    

    public void remove() {

        throw new UnsupportedOperationException("Can't remove element");

    }

}

