// *********************************************
// Modificications pour mise en libre :
// Modif A le 27/01/2000 par Marc Dauplait :
// Exploitation de l'attribut adrServeur = adresse du serveur
// Modif B le 31/01/2000 par Marc Dauplait :
// Remplacement de l'attribut adrServeur par urlApplet = URL de l'applet
// *********************************************

package carto.applet;

import carto.graphe.*;
import carto.rmi.*;
import carto.parse.GrapheParser;
import java.rmi.*;
import java.rmi.server.*;
import java.io.*;
import javax.swing.*;
import java.net.*;
import MonApplet; /* modif A*/

/**
* Cette classe s'occupe de charger un fichier XML en mmoire sous 
* forme de graphe.
* @author Fred
*/

public class CreeGraphe
{
	protected static String getGraphe(String unFichier)
	{
		String source=null;
		Fichier fichier;
		try 
		{
            //fichier = (Fichier)Naming.lookup("//mengam.enst-bretagne.fr/Fichier");
            //fichier = (Fichier)Naming.lookup("//penfret.enst-bretagne.fr/Fichier");
            //fichier = (Fichier)Naming.lookup("//"+MonApplet.adrServeur+"/Fichier"); /* modif A*/
            fichier = (Fichier)Naming.lookup("//"+MonApplet.urlApplet.getHost()+"/Fichier"); /* modif B*/
            source = fichier.getFichier(unFichier);
		}
		catch (FileNotFoundException e) 
		{    
			(new JOptionPane()).showMessageDialog(null,"Le fichier \""+unFichier
				+"\" n'a pu tre trouv","Erreur",JOptionPane.ERROR_MESSAGE);
		}
		catch (MalformedURLException e)
		{
			System.out.println("MalFormedURL exception: " + e.getMessage());
			e.printStackTrace();
		}
		catch (RemoteException e)
		{
			System.out.println("Remote exception: " + e.getMessage());
			e.printStackTrace();
		}
		catch (IOException e)
		{
		}
		catch (NotBoundException e)
		{
		}
		return source;
	}
	
	
	/** La mthode demande a la classe 'carto.parse.GrapheParser' de transformer
	* un String contenant du .xml dans une instance de la classe 'carto.graphe.Graphe'.
	* @return l'instance de 'Graphe' d'un fichier xml
	* @param source la rprsentation String d'un fichier .xml (ne pas un rpertoire)
	*/
	
	protected static Graphe parser(String source) // source n'est pas un repertoire
	{  //reconvertir en 'Reader' pour que le parseur sache le traiter
		Graphe gr=null;
		StringBufferInputStream sbis;
		try
		{
			if(source!=null) {
				//StringBufferInputStream sbis = new StringBufferInputStream(source);
				sbis = new StringBufferInputStream(source);
			} else
				sbis = new StringBufferInputStream("");
            GrapheParser parser = new GrapheParser();
            gr=parser.parse(sbis);
		}
		catch (Exception ex)
		{
			System.out.println(ex.getMessage());
			ex.printStackTrace();
		}
		return gr;
	}
	
	public static Graphe initGraphe(String nomFichierXML)
	{
		try
		{
            GrapheParser parser = new GrapheParser();
            return new Graphe(parser(getGraphe(nomFichierXML)));
		}
		catch (Exception ex)
		{
			System.out.println(ex.getMessage());
			ex.printStackTrace();
		}
		return null;
	}
}
